Loading...
Searching...
No Matches
csr< T, distributed >

## Detailed Description

template<class T>
class rheolef::csr< T, distributed >

Definition at line 466 of file csr.h.

Inheritance diagram for csr< T, distributed >:

## Public Types

typedef csr_rep< T, distributed > | rep
typedef smart_pointer< rep > | base
typedef rep::memory_type | memory_type
typedef rep::size_type | size_type
typedef rep::element_type | element_type
typedef rep::iterator | iterator
typedef rep::const_iterator | const_iterator
typedef rep::data_iterator | data_iterator
typedef rep::const_data_iterator | const_data_iterator
Public Types inherited from smart_pointer< csr_rep< T, distributed > >
typedef csr_rep< T, distributed > | handled_type
typedef base::internal | internal

## Public Member Functions

| csr ()
template<class A >
| csr (const asr< T, memory_type, A > &a)
void | resize (const distributor &row_ownership, const distributor &col_ownership, size_type nnz1=0)
| csr (const std::initializer_list< details::csr_concat_value< T, distributed > > &init_list)
| csr (const std::initializer_list< details::csr_concat_line< T, distributed > > &init_list)
const distributor & | row_ownership () const
const distributor & | col_ownership () const
size_type | dis_nrow () const
size_type | dis_ncol () const
size_type | dis_nnz () const
size_type | dis_ext_nnz () const
bool | is_symmetric () const
void | set_symmetry (bool is_symm) const
void | set_symmetry_by_check (const T &tol=std::numeric_limits< T >::epsilon()) const
bool | is_definite_positive () const
void | set_definite_positive (bool is_defpos) const
size_type | pattern_dimension () const
void | set_pattern_dimension (size_type dim) const
T | max_abs () const
size_type | nrow () const
size_type | ncol () const
size_type | nnz () const
size_type | row_first_index () const
size_type | row_last_index () const
size_type | col_first_index () const
size_type | col_last_index () const
const_iterator | begin () const
const_iterator | end () const
iterator | begin_nonconst ()
iterator | end_nonconst ()
size_type | ext_nnz () const
const_iterator | ext_begin () const
const_iterator | ext_end () const
iterator | ext_begin_nonconst ()
iterator | ext_end_nonconst ()
size_type | jext2dis_j (size_type jext) const
int | constraint_process_rank () const
void | mult (const vec< element_type, distributed > &x, vec< element_type, distributed > &y) const
vec< element_type, distributed > | operator* (const vec< element_type, distributed > &x) const
void | trans_mult (const vec< element_type, distributed > &x, vec< element_type, distributed > &y) const
vec< element_type, distributed > | trans_mult (const vec< element_type, distributed > &x) const
csr< T, distributed > | operator+ (const csr< T, distributed > &b) const
csr< T, distributed > | operator- (const csr< T, distributed > &b) const
csr< T, distributed > | operator* (const csr< T, distributed > &b) const
csr< T, distributed > & | operator*= (const T &lambda)
void | dump (const std::string &name) const
Public Member Functions inherited from smart_pointer< csr_rep< T, distributed > >
| smart_pointer (csr_rep< T, distributed > *p=0)
| smart_pointer (void *count, internal i)
| smart_pointer (const smart_pointer< csr_rep< T, distributed > > &x)
smart_pointer< csr_rep< T, distributed > > & | operator= (const smart_pointer< csr_rep< T, distributed > > &x)
| ~smart_pointer ()
Public Member Functions inherited from smart_pointer_base< T, C >
| smart_pointer_base (T *p=0)
| smart_pointer_base (const smart_pointer_base< T, C > &)
| smart_pointer_base (void *count, internal)
smart_pointer_base< T, C > & | operator= (const smart_pointer_base< T, C > &)
| ~smart_pointer_base ()
const T * | pointer () const
const T & | data () const
const T * | operator-> () const
const T & | operator* () const
T * | pointer ()
T & | data ()
T * | operator-> ()
T & | operator* ()
int | reference_counter () const
counter * | get_count () const

## Member Typedef Documentation

## rep

template<class T >

typedef csr_rep<T,distributed> rep

Definition at line 471 of file csr.h.

## base

template<class T >

typedef smart_pointer<rep> base

Definition at line 472 of file csr.h.

## memory_type

template<class T >

typedef rep::memory_type memory_type

Definition at line 473 of file csr.h.

## size_type

template<class T >

typedef rep::size_type size_type

Definition at line 474 of file csr.h.

## element_type

template<class T >

typedef rep::element_type element_type

Definition at line 475 of file csr.h.

## iterator

template<class T >

typedef rep::iterator iterator

Definition at line 476 of file csr.h.

## const_iterator

template<class T >

typedef rep::const_iterator const_iterator

Definition at line 477 of file csr.h.

## data_iterator

template<class T >

typedef rep::data_iterator data_iterator

Definition at line 478 of file csr.h.

## const_data_iterator

template<class T >

typedef rep::const_data_iterator const_data_iterator

Definition at line 479 of file csr.h.

## Constructor & Destructor Documentation

## csr() [1/4]

template<class T >

csr | ( |  | ) |

Definition at line 483 of file csr.h.

## csr() [2/4]

template<class T >
template<class A >

csr | ( | const asr< T, memory_type, A > & | a | ) |

explicit

Definition at line 485 of file csr.h.

## csr() [3/4]

template<class T >

csr | ( | const std::initializer_list< details::csr_concat_value< T, distributed > > & | init_list | ) |

## csr() [4/4]

template<class T >

csr | ( | const std::initializer_list< details::csr_concat_line< T, distributed > > & | init_list | ) |

## Member Function Documentation

## resize()

template<class T >

void resize | ( | const distributor & | row_ownership,
|  | const distributor & | col_ownership,
|  | size_type | nnz1 = `0`
| ) |  |

Definition at line 486 of file csr.h.

## row_ownership()

template<class T >

const distributor & row_ownership | ( |  | ) | const

Definition at line 497 of file csr.h.

## col_ownership()

template<class T >

const distributor & col_ownership | ( |  | ) | const

Definition at line 498 of file csr.h.

## dis_nrow()

template<class T >

size_type dis_nrow | ( |  | ) | const

Definition at line 499 of file csr.h.

## dis_ncol()

template<class T >

size_type dis_ncol | ( |  | ) | const

Definition at line 500 of file csr.h.

## dis_nnz()

template<class T >

size_type dis_nnz | ( |  | ) | const

Definition at line 501 of file csr.h.

## dis_ext_nnz()

template<class T >

size_type dis_ext_nnz | ( |  | ) | const

Definition at line 502 of file csr.h.

## is_symmetric()

template<class T >

bool is_symmetric | ( |  | ) | const

Definition at line 503 of file csr.h.

## set_symmetry()

template<class T >

void set_symmetry | ( | bool | is_symm | ) | const

Definition at line 504 of file csr.h.

## set_symmetry_by_check()

template<class T >

void set_symmetry_by_check | ( | const T & | tol = `std::numeric_limits<T>::epsilon()` | ) | const

Definition at line 505 of file csr.h.

## is_definite_positive()

template<class T >

bool is_definite_positive | ( |  | ) | const

Definition at line 507 of file csr.h.

## set_definite_positive()

template<class T >

void set_definite_positive | ( | bool | is_defpos | ) | const

Definition at line 508 of file csr.h.

## pattern_dimension()

template<class T >

size_type pattern_dimension | ( |  | ) | const

Definition at line 509 of file csr.h.

## set_pattern_dimension()

template<class T >

void set_pattern_dimension | ( | size_type | dim | ) | const

Definition at line 510 of file csr.h.

## max_abs()

template<class T >

T max_abs | ( |  | ) | const

Definition at line 511 of file csr.h.

## nrow()

template<class T >

size_type nrow | ( |  | ) | const

Definition at line 514 of file csr.h.

## ncol()

template<class T >

size_type ncol | ( |  | ) | const

Definition at line 515 of file csr.h.

## nnz()

template<class T >

size_type nnz | ( |  | ) | const

Definition at line 516 of file csr.h.

## row_first_index()

template<class T >

size_type row_first_index | ( |  | ) | const

Definition at line 519 of file csr.h.

## row_last_index()

template<class T >

size_type row_last_index | ( |  | ) | const

Definition at line 520 of file csr.h.

## col_first_index()

template<class T >

size_type col_first_index | ( |  | ) | const

Definition at line 521 of file csr.h.

## col_last_index()

template<class T >

size_type col_last_index | ( |  | ) | const

Definition at line 522 of file csr.h.

## begin()

template<class T >

const_iterator begin | ( |  | ) | const

Definition at line 524 of file csr.h.

## end()

template<class T >

const_iterator end | ( |  | ) | const

Definition at line 525 of file csr.h.

## begin_nonconst()

template<class T >

iterator begin_nonconst | ( |  | ) |

Definition at line 526 of file csr.h.

## end_nonconst()

template<class T >

iterator end_nonconst | ( |  | ) |

Definition at line 527 of file csr.h.

## ext_nnz()

template<class T >

size_type ext_nnz | ( |  | ) | const

Definition at line 530 of file csr.h.

## ext_begin()

template<class T >

const_iterator ext_begin | ( |  | ) | const

Definition at line 531 of file csr.h.

## ext_end()

template<class T >

const_iterator ext_end | ( |  | ) | const

Definition at line 532 of file csr.h.

## ext_begin_nonconst()

template<class T >

iterator ext_begin_nonconst | ( |  | ) |

Definition at line 533 of file csr.h.

## ext_end_nonconst()

template<class T >

iterator ext_end_nonconst | ( |  | ) |

Definition at line 534 of file csr.h.

## jext2dis_j()

template<class T >

size_type jext2dis_j | ( | size_type | jext | ) | const

Definition at line 535 of file csr.h.

## constraint_process_rank()

template<class T >

int constraint_process_rank | ( |  | ) | const

## mult()

template<class T >

void mult | ( | const vec< element_type, distributed > & | x,
|  | vec< element_type, distributed > & | y
| ) |  | const

Definition at line 542 of file csr.h.

## operator*() [1/2]

template<class T >

vec< element_type, distributed > operator* | ( | const vec< element_type, distributed > & | x | ) | const

Definition at line 545 of file csr.h.

## trans_mult() [1/2]

template<class T >

void trans_mult | ( | const vec< element_type, distributed > & | x,
|  | vec< element_type, distributed > & | y
| ) |  | const

Definition at line 550 of file csr.h.

## trans_mult() [2/2]

template<class T >

vec< element_type, distributed > trans_mult | ( | const vec< element_type, distributed > & | x | ) | const

Definition at line 553 of file csr.h.

## operator+()

template<class T >

csr< T, distributed > operator+ | ( | const csr< T, distributed > & | b | ) | const

Definition at line 671 of file csr.h.

## operator-()

template<class T >

csr< T, distributed > operator- | ( | const csr< T, distributed > & | b | ) | const

Definition at line 679 of file csr.h.

## operator*() [2/2]

template<class T >

csr< T, distributed > operator* | ( | const csr< T, distributed > & | b | ) | const

Definition at line 701 of file csr.h.

## operator*=()

template<class T >

csr< T, distributed > & operator*= | ( | const T & | lambda | ) |

Definition at line 564 of file csr.h.

## dump()

template<class T >

void dump | ( | const std::string & | name | ) | const

Definition at line 570 of file csr.h.

The documentation for this class was generated from the following file:

- /build/rheolef-Hrneba/rheolef-7.2/linalg/lib/csr.h